function [recimg,t,iter]=nonlinearcg(img,ind,maxiter,epsilon,type)
%Function to find the minization of the function by nonlinear cg type method.
%Input: 
%   maxiter --- maximum number of iterations allowed
%   epsilon --- the stop criteria
%      type --- the search direction 
%Output:
%   recimg  --- the minimizer
%   iter --- the number of iterations
%   t --- the cputime.


%if mask=1, it is a noised point, else it is unnoised.
%rimg is the recovered image.
%m1 m2 m3 m4 are masks which.
t=cputime;
global mask rimg m1 m2 m3 m4 mmask;
global alpha
alpha=10;

[nn,mm]=size(ind);
rimg=img;
mask=ind;
gtol=[];
tol=[];
%use reflection boundary condition.
maskext=[mask(:,1) mask mask(:,mm)];
maskext=[maskext(1,:);maskext;maskext(mm,:)];

m1=2-maskext(2:nn+1,1:mm);
m2=2-maskext(2:nn+1,3:mm+2);
m3=2-maskext(1:nn,2:mm+1);
m4=2-maskext(3:nn+2,2:mm+1);

m5=2-maskext(1:nn,1:mm);
m6=2-maskext(3:nn+2,1:mm);
m7=2-maskext(1:nn,3:mm+2);
m8=2-maskext(3:nn+2,3:mm+2);

mmask=[m1(mask) m2(mask) m3(mask) m4(mask) m5(mask) m6(mask) m7(mask) m8(mask)];

xk=img(ind);
n=size(xk,1);

iter=0;
%delta=sqrt(alpha-1)/16;
delta=2*sqrt(99)/16;
%delta=1/16;
[fk,gk]=evalf(xk,3);
dk=gk;
alphak=-delta;
xk=xk+alphak*dk;
gk1=gk;fk1=fk;
[fk,gk]=evalf(xk,3);

ftol=1;
xtol=1;

while (iter<maxiter && ( ftol>epsilon || xtol>1e-4))
    dk1=dk;
    
    if type=='FR'
        betak=(gk'*gk)/(gk1'*gk1);
    elseif type=='PR'
        betak=(gk'*(gk-gk1))/(gk1'*gk1);
    elseif type=='HS'
        betak=(gk'*(gk-gk1))/(dk1'*(gk1-gk));
    elseif type=='CD'
        betak=(gk'*gk)/(dk1'*gk1);
    elseif type=='DY'
        betak=(gk'*gk)/(dk1'*(gk1-gk));
    end
    
    dk=gk+betak*dk1;
    alphak=delta*(gk'*dk)/(dk'*dk);
    xk=xk+alphak*dk;
    %xtol=norm(alphak*dk,inf)/255;
    xtol=norm(alphak*dk)/norm(xk);
    gk1=gk;fk1=fk;
    [fk,gk]=evalf(xk,3);
    ftol=abs(fk1-fk)/abs(fk1);
    iter=iter+1;
    disp(['xtol=' num2str(xtol) ', ftol=' num2str(ftol) ' at steps ' num2str(iter)]); 
    % disp(['xtol=' num2str(xtol) ', ftol=' num2str(ftol) ' at steps ' num2str(iter) ' gradient= ' num2str(norm(gk(:),inf))]);    
end
recimg=rimg;
recimg(ind)=xk;
t=cputime-t;